
Foreman - Bug #2730

API call without /api/ in URL raise 500 error (1.2-RC3)

07/01/2013 10:46 AM - Romain Vrignaud

Status: Resolved   

Priority: Normal   

Assignee:    

Category: API   

Target version:    

Difficulty:  Fixed in Releases:  

Triaged:  Found in Releases:  

Bugzilla link:  Red Hat JIRA:  

Pull request:    

Description

When querying foreman without /api/ in URL I get 500 error code.

I have same results with users, hosts, reports.

Exact same query with /api/ is working fine.

Started GET "/users" for 192.168.200.11 at 2013-07-01 16:44:57 +0200

Processing by UsersController#index as JSON

Parameters: {"user"=>{}}

SSO failed, falling back to login form

Operation FAILED: undefined method `allowed_to?' for nil:NilClass

/opt/foreman/app/controllers/users_controller.rb:132:in `authorize'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:530:in `block (2 levels) in run

_3136698978933429510__process_action__1784830483115556495__callbacks'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:215:in `block in 

conditional_callback_around_4590'

/opt/foreman/lib/foreman/thread_session.rb:31:in `clear_thread'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:214:in

`_conditional_callback_around_4590'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:415:in `block in _run

_3136698978933429510__process_action__1784830483115556495__callbacks'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:215:in `block in 

conditional_callback_around_4589'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:326:in `around'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:310:in `_callback_around_13'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:214:in

`_conditional_callback_around_4589'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:414:in `_run

_3136698978933429510__process_action__1784830483115556495__callbacks'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:405:in `__run_callback'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:385:in `_run_process_action_callbacks'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:81:in `run_callbacks'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/abstract_controller/callbacks.rb:17:in `process_action'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_controller/metal/rescue.rb:29:in `process_action'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_controller/metal/instrumentation.rb:30:in `block in process_action'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/notifications.rb:123:in `block in instrument'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/notifications/instrumenter.rb:20:in `instrument'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/notifications.rb:123:in `instrument'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_controller/metal/instrumentation.rb:29:in `process_action'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_controller/metal/params_wrapper.rb:207:in `process_action'

/opt/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.13/lib/active_record/railties/controller_runtime.rb:18:in `process_action'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/abstract_controller/base.rb:121:in `process'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/abstract_controller/rendering.rb:45:in `process'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_controller/metal.rb:203:in `dispatch'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_controller/metal/rack_delegation.rb:14:in `dispatch'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_controller/metal.rb:246:in `block in action'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/routing/route_set.rb:73:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/routing/route_set.rb:73:in `dispatch'
/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/routing/route_set.rb:36:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/journey-1.0.4/lib/journey/router.rb:68:in `block in call'

/opt/foreman/vendor/ruby/1.9.1/gems/journey-1.0.4/lib/journey/router.rb:56:in `each'

/opt/foreman/vendor/ruby/1.9.1/gems/journey-1.0.4/lib/journey/router.rb:56:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/routing/route_set.rb:612:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/apipie-rails-0.0.16/lib/apipie/static_dispatcher.rb:56:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-openid-1.3.1/lib/rack/openid.rb:98:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/best_standards_support.rb:17:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/etag.rb:23:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/conditionalget.rb:25:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/head.rb:14:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/params_parser.rb:21:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/flash.rb:242:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/session/abstract/id.rb:210:in `context'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/session/abstract/id.rb:205:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/cookies.rb:341:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.13/lib/active_record/query_cache.rb:64:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/activerecord-3.2.13/lib/active_record/connection_adapters/abstract/connection_pool.rb:479:in

`call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/callbacks.rb:28:in `block in call'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:405:in

`_run__1398251870328032996__call__2588499639973001370__callbacks'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:405:in `__run_callback'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:385:in `_run_call_callbacks'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/callbacks.rb:81:in `run_callbacks'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/callbacks.rb:27:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/remote_ip.rb:31:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/debug_exceptions.rb:16:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/show_exceptions.rb:56:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/railties-3.2.13/lib/rails/rack/logger.rb:32:in `call_app'

/opt/foreman/vendor/ruby/1.9.1/gems/railties-3.2.13/lib/rails/rack/logger.rb:16:in `block in call'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/tagged_logging.rb:22:in `tagged'

/opt/foreman/vendor/ruby/1.9.1/gems/railties-3.2.13/lib/rails/rack/logger.rb:16:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/request_id.rb:22:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/methodoverride.rb:21:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/runtime.rb:17:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/activesupport-3.2.13/lib/active_support/cache/strategy/local_cache.rb:72:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/lock.rb:15:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/actionpack-3.2.13/lib/action_dispatch/middleware/static.rb:63:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-cache-1.2/lib/rack/cache/context.rb:136:in `forward'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-cache-1.2/lib/rack/cache/context.rb:245:in `fetch'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-cache-1.2/lib/rack/cache/context.rb:185:in `lookup'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-cache-1.2/lib/rack/cache/context.rb:66:in `call!'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-cache-1.2/lib/rack/cache/context.rb:51:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/railties-3.2.13/lib/rails/engine.rb:479:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/railties-3.2.13/lib/rails/application.rb:223:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/railties-3.2.13/lib/rails/railtie/configurable.rb:30:in `method_missing'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/builder.rb:134:in `call'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/urlmap.rb:64:in `block in call'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/urlmap.rb:49:in `each'

/opt/foreman/vendor/ruby/1.9.1/gems/rack-1.4.5/lib/rack/urlmap.rb:49:in `call'

/usr/lib/ruby/vendor_ruby/phusion_passenger/rack/request_handler.rb:96:in `process_request'

/usr/lib/ruby/vendor_ruby/phusion_passenger/abstract_request_handler.rb:516:in `accept_and_process_next_request'

/usr/lib/ruby/vendor_ruby/phusion_passenger/abstract_request_handler.rb:274:in `main_loop'

/usr/lib/ruby/vendor_ruby/phusion_passenger/rack/application_spawner.rb:206:in `start_request_handler'

/usr/lib/ruby/vendor_ruby/phusion_passenger/rack/application_spawner.rb:171:in `block in handle_spawn_application'

/usr/lib/ruby/vendor_ruby/phusion_passenger/utils.rb:479:in `safe_fork'

/usr/lib/ruby/vendor_ruby/phusion_passenger/rack/application_spawner.rb:166:in `handle_spawn_application'

/usr/lib/ruby/vendor_ruby/phusion_passenger/abstract_server.rb:357:in `server_main_loop'

/usr/lib/ruby/vendor_ruby/phusion_passenger/abstract_server.rb:206:in `start_synchronously'

/usr/lib/ruby/vendor_ruby/phusion_passenger/abstract_server.rb:180:in `start'

/usr/lib/ruby/vendor_ruby/phusion_passenger/rack/application_spawner.rb:129:in `start'

/usr/lib/ruby/vendor_ruby/phusion_passenger/spawn_manager.rb:253:in `block (2 levels) in spawn_rack_application'

/usr/lib/ruby/vendor_ruby/phusion_passenger/abstract_server_collection.rb:132:in `lookup_or_add'

/usr/lib/ruby/vendor_ruby/phusion_passenger/spawn_manager.rb:246:in `block in spawn_rack_application'

/usr/lib/ruby/vendor_ruby/phusion_passenger/abstract_server_collection.rb:82:in `block in synchronize'

<internal:prelude>:10:in `synchronize'
/usr/lib/ruby/vendor_ruby/phusion_passenger/abstract_server_collection.rb:79:in `synchronize'

/usr/lib/ruby/vendor_ruby/phusion_passenger/spawn_manager.rb:244:in `spawn_rack_application'

/usr/lib/ruby/vendor_ruby/phusion_passenger/spawn_manager.rb:137:in `spawn_application'

/usr/lib/ruby/vendor_ruby/phusion_passenger/spawn_manager.rb:275:in `handle_spawn_application'

/usr/lib/ruby/vendor_ruby/phusion_passenger/abstract_server.rb:357:in `server_main_loop'

/usr/lib/ruby/vendor_ruby/phusion_passenger/abstract_server.rb:206:in `start_synchronously'

/usr/share/phusion-passenger/helper-scripts/passenger-spawn-server:99:in `<main>'

Rendered common/500.html.erb within layouts/application (2.8ms)

Completed 500 Internal Server Error in 6ms (Views: 4.6ms | ActiveRecord: 0.0ms)

History

#1 - 07/01/2013 10:46 AM - Romain Vrignaud

- Category set to API

#2 - 07/01/2013 10:47 AM - Romain Vrignaud

- Subject changed from API call withou /api/ in URL raise 500 error (1.2-RC3) to API call without /api/ in URL raise 500 error (1.2-RC3)

#3 - 07/01/2013 10:52 AM - Dominic Cleal

Is authorize_login_delegation_api in More>Settings>General set to true?

#4 - 07/03/2013 03:39 AM - Joseph Magen

/api/users JSON calls uses the authorize method in Api::BaseController

/users JSON calls uses the require_login method in ApplicationController.  Somehow in your call User.current is nil.  Because of this, you get the error

Operation FAILED: undefined method `allowed_to?' for nil:NilClass

but I can't duplicate it.  In settings.yaml, do you have login: true or false

#5 - 05/18/2017 06:48 PM - Anonymous

- Description updated

- Status changed from New to Resolved

not reproducible
